#include <sys/types.h>

#if defined(HAVE_CONFIG_H)
#include "config.h"
#endif

/* largest prime smaller than 65536 */
#define BASE 65521
/* NMAX is the largest n such that 255n(n+1)/2 + (n+1)(BASE-1) <= 2^32-1 */
#define NMAX 5552

#define DO1(buf,i)  {s1 += buf[i]; s2 += s1;}
#define DO2(buf,i)  DO1(buf,i); DO1(buf,i+1);
#define DO4(buf,i)  DO2(buf,i); DO2(buf,i+2);
#define DO8(buf,i)  DO4(buf,i); DO4(buf,i+4);
#define DO16(buf)   DO8(buf,0); DO8(buf,8);

#define BS 16
#define DO DO16

u_int32_t
my_adler32 (u_int32_t adler, const u_int8_t *buf, size_t len)
{
	u_int32_t s1 = adler & 0xffff;
	u_int32_t s2 = (adler >> 16) & 0xffff;
	size_t k;

	while (len) {
		k = len < NMAX ? len : NMAX;
		len -= k;
		while (k >= BS) {
			DO(buf);
			buf += BS;
			k -= BS;
		}
		while (k--) {
			s1 += *buf++;
			s2 += s1;
		}
		s1 %= BASE;
		s2 %= BASE;
	}

	return (s2 << 16) | s1;
}
